package de.fd.fh.network;

import de.fd.fh.shared.Utils;
import de.fd.fh.shared.network.messages.LoginResponse;
import de.fd.fh.shared.network.messages.RegistrateRequest;
import feign.Headers;
import feign.Param;
import feign.RequestLine;
import feign.Response;

public interface AccessClient
{
    @RequestLine("POST /accounts/registrate")
    Response registrate(RegistrateRequest request);

    @RequestLine("POST /accounts/login")
    @Headers(Utils.AUTHENTICATION_HEADER + ":Basic {authToken}")
    LoginResponse login(@Param("authToken") final String authenticationHeader);

    @RequestLine("POST /accounts/logout")
    @Headers(Utils.AUTHENTICATION_HEADER + ":Bearer {authToken}")
    Response logout(@Param("authToken") final String authenticationHeader);

    @RequestLine("DELETE /accounts/{playerId}")
    Response deletePlayer(@Param("playerId") final String playerId);
}
