package de.fd.fh.network;

import feign.Feign;
import feign.gson.GsonDecoder;
import feign.gson.GsonEncoder;
import feign.okhttp.OkHttpClient;
import lombok.Getter;

@Getter
public class FeignClients
{
    private static final String BASE_URL = "http://localhost:4567";

    private AccessClient accessClient;
    private UserClient userClient;

    public FeignClients()
    {
        accessClient = buildClient(AccessClient.class);
        userClient = buildClient(UserClient.class);
    }

    <T> T buildClient(final Class<T> client)
    {
        return Feign.builder()
                .client(new OkHttpClient())
                .encoder(new GsonEncoder())
                .decoder(new GsonDecoder())
                .target(client, BASE_URL);
    }
}
