package de.fd.fh.network;

import de.fd.fh.shared.Utils;
import de.fd.fh.shared.network.messages.ChangeUserRequest;
import de.fd.fh.shared.network.messages.PlayerResponse;
import de.fd.fh.shared.network.messages.UserRequest;
import feign.Headers;
import feign.Param;
import feign.RequestLine;

public interface UserClient
{
    @RequestLine("POST /users")
    @Headers(Utils.AUTHENTICATION_HEADER + ":Bearer {authToken}")
    PlayerResponse updatePlayer(
            @Param("authToken") final String authenticationHeader,
            final ChangeUserRequest request
    );

    @RequestLine("GET /users/{userId}")
    @Headers(Utils.AUTHENTICATION_HEADER + ":Bearer {authToken}")
    UserRequest getShortPlayer(
            @Param("authToken") final String authenticationHeader,
            @Param("userId") final String userId
    );

    @RequestLine("GET /users")
    @Headers(Utils.AUTHENTICATION_HEADER + ":Bearer {authToken}")
    PlayerResponse getCurrentPlayer(
            @Param("authToken") final String authenticationHeader
    );
}
