package de.fd.fh;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class FigureRookTest
{
    // weißer Turm
    @Test
    void whiteRookValidMoveUp()
    {
        Figure f = new FigureRook();
        assertTrue(f.moveAllowed(Figure.fieldLength * 4 + 4,
                Figure.fieldLength * 0 + 4,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }

    @Test
    void whiteRookValidMoveDown()
    {
        Figure f = new FigureRook();
        assertTrue(f.moveAllowed(Figure.fieldLength * 4 + 4,
                Figure.fieldLength * 7 + 4,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }

    @Test
    void whiteRookInvalidMoveLeftUp() // diagonal nach links oben
    {
        Figure f = new FigureRook();
        assertFalse(f.moveAllowed(Figure.fieldLength * 4 + 4,
                Figure.fieldLength * 3 + 3,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }

    @Test
    void whiteRookInvalidMoveRightUp() // diagonal nach rechts oben
    {
        Figure f = new FigureRook();
        assertFalse(f.moveAllowed(Figure.fieldLength * 4 + 4,
                Figure.fieldLength * 3 + 5,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }

    @Test
    void whiteRookInvalidMoveLeftDown() // diagonal nach links unten
    {
        Figure f = new FigureRook();
        assertFalse(f.moveAllowed(Figure.fieldLength * 4 + 4,
                Figure.fieldLength * 5 + 3,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }

    @Test
    void whiteRookInvalidMoveRightDown() // diagonal nach rechts unten
    {
        Figure f = new FigureRook();
        assertFalse(f.moveAllowed(Figure.fieldLength * 4 + 4,
                Figure.fieldLength * 5 + 5,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }
}