package de.fd.fh;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class FigureTest
{
    @Test
    void checkMoveWithInvalidFieldSmall() // Feldgröße sollte 8*8 betragen
    {
        Figure f = new Figure();
        assertFalse(f.moveAllowed(Figure.fieldLength * 6 + 0,
                Figure.fieldLength * 5 + 0,
                new Figure[0]));
    }

    @Test
    void checkMoveWithInvalidFieldBigger() // Feldgröße sollte 8*8 betragen
    {
        Figure f = new Figure();
        assertFalse(f.moveAllowed(Figure.fieldLength * 6 + 0,
                Figure.fieldLength * 5 + 0,
                new Figure[8*9]));
    }

    @Test
    void checkMoveWithInvalidFieldCorrect() // Feldgröße sollte 8*8 betragen
    {
        Figure f = new Figure();
        assertTrue(f.moveAllowed(Figure.fieldLength * 6 + 0,
                Figure.fieldLength * 5 + 0,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }

    @Test
    void checkMoveWithoutNewDestination()
    {
        Figure f = new Figure();
        assertFalse(f.moveAllowed(Figure.fieldLength * 6 + 0,
                Figure.fieldLength * 6 + 0,
                new Figure[Figure.fieldLength * Figure.fieldLength]));
    }
}