package de.fd.fh.server.access;

import de.fd.fh.server.user.UserId;
import dev.morphia.annotations.Embedded;
import dev.morphia.annotations.Entity;
import dev.morphia.annotations.Id;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;

@Entity("login")
@NoArgsConstructor
@AllArgsConstructor
@Getter
public class Access
{
    @Id
    private String _id;

    private String name;

    private String password;

    @Embedded
    private UserId userId;

    @Embedded
    private AccessToken token;

    private Role role;

    void removeToken()
    {
        this.token = null;
    }

    void setToken(final AccessToken token)
    {
        this.token = token;
    }

    void updatePassword(final String newPassword)
    {
        this.password = newPassword;
    }

    void rename(final String name)
    {
        this.name = name;
    }
}
