package de.fd.fh.server.access;

import de.fd.fh.server.user.UserId;
import org.junit.jupiter.api.Test;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.equalTo;
import static org.junit.jupiter.api.Assertions.*;

class AccessTokenTest
{
    @Test
    void given_accessData_when_createAccessToken_should_createGeneratedToken()
    {
        final Access access = new Access(
                "testId",
                "testName",
                "testPwd",
                UserId.of("12345"),
                null,
                Role.USER);

        final AccessToken result = AccessToken.of(access);

        assertNotNull(result.getCreatedDate());
        assertNotNull(result.getToken());
        assertThat(result.getToken().length(), equalTo(64));
        assertEquals(result.getRole(), Role.USER);
        assertEquals(result.getUserId(), UserId.of("12345"));
    }

    @Test
    void testPrePersist()
    {
        final Access access = new Access(
                "testId",
                "testName",
                "testPwd",
                UserId.of("12345"),
                null,
                Role.USER);

        final AccessToken accessToken = AccessToken.of(access);

        accessToken.prePersist();

        assertNotNull(accessToken.getCreatedDate());
    }
}